import { Server } from 'socket.io'

import { BaseCommand } from '@/application/base/baseCommand'
import { SocketEvent } from '@/application/enums'

type CommandInput = string[]

export default class AlertCommand extends BaseCommand {
  public execute(input: CommandInput): void {
    const message: string = input.join(' ') ?? null
    if (!message) return console.log('message is required')
    this.io.emit(SocketEvent.NOTIFICATION, { message: message })
  }
}
